package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.DataAudit;

/**
 * 实体[DataAuditDetail] 数据对象
 */
@TableName(value = "T_SRFDATAAUDITDETAIL",resultMap = "DataAuditDetailResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class DataAuditDetail extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private DataAudit dataaudit;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @TableId(value= "dataauditdetailid",type=IdType.UUID)//指定主键生成策略
    private String dataauditdetailid;
    private String dataauditdetailname;
    private String dataauditid;
    private String dataauditname;
    private String newtext;
    private String newvalue;
    private String oldtext;
    private String oldvalue;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[数据审计明细标识]
     *  @param dataauditdetailid
     */
    public void setDataauditdetailid(String dataauditdetailid){
        if(StringUtils.isEmpty(dataauditdetailid))
            dataauditdetailid=null;
        this.dataauditdetailid = dataauditdetailid;
        this.set("dataauditdetailiddirtyflag",true);
    }
    /**
     *  获取属性值[数据审计明细标识]
     */
    public String getDataauditdetailid(){
        return this.dataauditdetailid;
    }
    /**
     *  重置属性值[数据审计明细标识]
     */
    public void resetDataauditdetailid(){
        this.set("dataauditdetailiddirtyflag",false);
        this.dataauditdetailid = null;
    }
    /**
     *  设置属性值[属性]
     *  @param dataauditdetailname
     */
    public void setDataauditdetailname(String dataauditdetailname){
        if(StringUtils.isEmpty(dataauditdetailname))
            dataauditdetailname=null;
        this.dataauditdetailname = dataauditdetailname;
        this.set("dataauditdetailnamedirtyflag",true);
    }
    /**
     *  获取属性值[属性]
     */
    public String getDataauditdetailname(){
        return this.dataauditdetailname;
    }
    /**
     *  重置属性值[属性]
     */
    public void resetDataauditdetailname(){
        this.set("dataauditdetailnamedirtyflag",false);
        this.dataauditdetailname = null;
    }
    /**
     *  设置属性值[数据审计]
     *  @param dataauditid
     */
    public void setDataauditid(String dataauditid){
        if(StringUtils.isEmpty(dataauditid))
            dataauditid=null;
        this.dataauditid = dataauditid;
        this.set("dataauditiddirtyflag",true);
    }
    /**
     *  获取属性值[数据审计]
     */
    public String getDataauditid(){
        return this.dataauditid;
    }
    /**
     *  重置属性值[数据审计]
     */
    public void resetDataauditid(){
        this.set("dataauditiddirtyflag",false);
        this.dataauditid = null;
    }
    /**
     *  设置属性值[数据审计]
     *  @param dataauditname
     */
    public void setDataauditname(String dataauditname){
        if(StringUtils.isEmpty(dataauditname))
            dataauditname=null;
        this.dataauditname = dataauditname;
        this.set("dataauditnamedirtyflag",true);
    }
    /**
     *  获取属性值[数据审计]
     */
    public String getDataauditname(){
        //填充物理化的外键值附加数据
        if(StringUtils.isEmpty(this.dataauditname)&&(!StringUtils.isEmpty(this.getDataauditid())) && this.getDataaudit()!=null)
        {
            this.dataauditname = this.getDataaudit().getDataauditname();
            this.set("dataauditnamedirtyflag",true);
        }
        return this.dataauditname;
    }
    /**
     *  重置属性值[数据审计]
     */
    public void resetDataauditname(){
        this.set("dataauditnamedirtyflag",false);
        this.dataauditname = null;
    }
    /**
     *  设置属性值[新值（文本）]
     *  @param newtext
     */
    public void setNewtext(String newtext){
        if(StringUtils.isEmpty(newtext))
            newtext=null;
        this.newtext = newtext;
        this.set("newtextdirtyflag",true);
    }
    /**
     *  获取属性值[新值（文本）]
     */
    public String getNewtext(){
        return this.newtext;
    }
    /**
     *  重置属性值[新值（文本）]
     */
    public void resetNewtext(){
        this.set("newtextdirtyflag",false);
        this.newtext = null;
    }
    /**
     *  设置属性值[新值]
     *  @param newvalue
     */
    public void setNewvalue(String newvalue){
        if(StringUtils.isEmpty(newvalue))
            newvalue=null;
        this.newvalue = newvalue;
        this.set("newvaluedirtyflag",true);
    }
    /**
     *  获取属性值[新值]
     */
    public String getNewvalue(){
        return this.newvalue;
    }
    /**
     *  重置属性值[新值]
     */
    public void resetNewvalue(){
        this.set("newvaluedirtyflag",false);
        this.newvalue = null;
    }
    /**
     *  设置属性值[原值（文本）]
     *  @param oldtext
     */
    public void setOldtext(String oldtext){
        if(StringUtils.isEmpty(oldtext))
            oldtext=null;
        this.oldtext = oldtext;
        this.set("oldtextdirtyflag",true);
    }
    /**
     *  获取属性值[原值（文本）]
     */
    public String getOldtext(){
        return this.oldtext;
    }
    /**
     *  重置属性值[原值（文本）]
     */
    public void resetOldtext(){
        this.set("oldtextdirtyflag",false);
        this.oldtext = null;
    }
    /**
     *  设置属性值[原值]
     *  @param oldvalue
     */
    public void setOldvalue(String oldvalue){
        if(StringUtils.isEmpty(oldvalue))
            oldvalue=null;
        this.oldvalue = oldvalue;
        this.set("oldvaluedirtyflag",true);
    }
    /**
     *  获取属性值[原值]
     */
    public String getOldvalue(){
        return this.oldvalue;
    }
    /**
     *  重置属性值[原值]
     */
    public void resetOldvalue(){
        this.set("oldvaluedirtyflag",false);
        this.oldvalue = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
     /**
     *  获取主实体关联数据[DataAudit]
     */
    public DataAudit getDataaudit() {
        return dataaudit;
    }
    /**
     *  设置主实体关联数据[DataAudit]
     */
    public void setDataaudit(DataAudit dataaudit) {
        this.dataaudit = dataaudit;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetDataauditdetailid();
        resetDataauditdetailname();
        resetDataauditid();
        resetDataauditname();
        resetNewtext();
        resetNewvalue();
        resetOldtext();
        resetOldvalue();
        resetUpdatedate();
        resetUpdateman();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public DataAuditDetail copyTo(DataAuditDetail targetEntity)
	{
		BeanCopier copier=BeanCopier.create(DataAuditDetail.class, DataAuditDetail.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetDataauditdetailid();
		return targetEntity;
	}
}